/*
Enhanced tcplogger. v. 0.0. by CyberPsychotic(fygrave@tigerteam.net)
check http://www.kalug.lug.net/coding/ for recent updates.


   This piece is based on tcplogd.c v 2.1 (20th dic. 1998) for linux
   by phroid (phroid@cyberdude.com) which was a simple hack of 
   Mike Edulla's tcplogger.

*/
#include "tcplogd.h"
#include "tcplogd.conf.h"
extern int errno;

int debug;
volatile double packetcount;
volatile unsigned char flood;

int go_background(void);
char *hostlookup(unsigned long int);
char *servlookup(unsigned short);
void logpacket(struct ippkt *,int );
extern void set_signals(void);

struct ippkt pkt;

int go_background(void)
{
   int fd;
   int fs;

   if(getppid() != 1) /* sanity check */
   {
      signal(SIGTTOU, SIG_IGN);
      signal(SIGTTIN, SIG_IGN);
      signal(SIGTSTP, SIG_IGN);
      fs=fork();
      if(fs < 0)
      {
         perror("fork");
         exit(1);
      }
      if(fs > 0) exit(0);
      fs=fork();
      /* fork twice, to make sure we are not session leader */
      if (fs <0) 
      {
	      perror("fork");
	      exit(1);
      }

      if(fs > 0) exit(0);

      setsid();
   }
   for(fd=0;fd < NOFILE;fd++) close(fd);
   errno=0;
   chdir("/");
   umask(0);
   return 0;
}

int main(int argc,char **argv)
{
   int s;
   int rdln;

   setuid(0);
   if(geteuid() != 0)
   {
      printf("This program requires root privledges\n");
      exit(0);
   }

   if (scan_conf()==-1) { fprintf(stderr,"config file error\n");
   			  exit(1);
   }

   if (argc>1 && argv[1][1]=='d') debug=1; else debug=0;
   
   if(!debug) go_background();
   set_signals();
   s=socket(AF_INET, SOCK_RAW, IPPROTO_TCP);
   openlog("tcplogd", 0, LOGFACILITY);
syslog(LOGFACILITY|LOG_INFO,"tcplogd %s [%i] started.",VERSION,getpid());
   while(1)
   {
      rdln=read(s, (struct ippkt *)&pkt, 9999);
     if(rdln>0) logpacket(&pkt,rdln);
   }
}

void logpacket(struct ippkt *pack,int packlen) {
struct ports *pports=ports_start;
struct tcpflags *ptcp=tcpflag_start;
char srca[BUFSIZE+1],dsta[BUFSIZE+1];


 if (packetcount>floodlimit && !flood) { flood=1;
	 			syslog(LOGFACILITY|LOG_WARNING,
					"Flood detected.");
				if(debug) printf("Flood detected\n");
				return;
 }
 if (flood) return;
while(pports->port!=-1 && pports->next!=NULL){ 
	if (pack->tcp.th_dport == htons(pports->port)) return; /* ignore */
	pports=pports->next;
}

while(ptcp->facility!=-1 && ptcp->next!=NULL) {
      if((pack->tcp.th_flags & 0x3f) == ptcp->flags) {
 	      packetcount++;
	      snprintf(srca,BUFSIZE,"%s[%s]:%s",
			      hostlookup(pack->ip.ip_src.s_addr),
			      inet_ntoa(pack->ip.ip_src),
			      servlookup(pack->tcp.th_sport));
	       snprintf(dsta,BUFSIZE,"%s[%s]:%s",
			      hostlookup(pack->ip.ip_dst.s_addr),
			      inet_ntoa(pack->ip.ip_dst),
			      servlookup(pack->tcp.th_dport));
	       
	syslog(LOGFACILITY|ptcp->facility
	, "%s %s->%s",ptcp->name,srca,dsta);
	if (debug) printf("from %s to %s\nseq: 0x%0x ack:0x%0x\noff: 0x%0x"
	"win 0x%0x\n\n",srca,dsta,ntohl(pack->tcp.th_seq),
	ntohl(pack->tcp.th_ack),
	ntohs(pack->tcp.th_off),ntohs(pack->tcp.th_win));
      } /* if */
      ptcp=ptcp->next;
	} /* while */
}

char *hostlookup(unsigned long int in)
{
   static char blah[BUFSIZE+1];
   struct in_addr i;
   struct hostent *he;

   i.s_addr=in;
   he=gethostbyaddr((char *)&i, sizeof(struct in_addr),AF_INET);
   if(he == NULL) strncpy(blah, inet_ntoa(i),BUFSIZE);
   else strncpy(blah, he->h_name,BUFSIZE);
   return blah;
}


char *servlookup(unsigned short port)
{
   struct servent *se;
   static char buff[BUFSIZE+1];

   se=getservbyport(port, "tcp");
   if(se == NULL) snprintf(buff,BUFSIZE, "[%d]", ntohs(port));
   else snprintf(buff,BUFSIZE,"%s", se->s_name);
   return buff;
}

